local 
Tinkr,
---@type Bastion
Bastion = ...

local ArcaneModule = Bastion.Module:New('arcane')
local Player = Bastion.UnitManager:Get('player')
local Target = Bastion.UnitManager:Get('target')
local None = Bastion.UnitManager:Get('none')
local AutoAttack = Bastion.SpellBook:GetSpell(6603)

local CDsEnabled = false

local Command = Bastion.Command:New('arcane')

Command:Register('cooldowns', 'Toggle Arcane CDs', function()
    CDsEnabled = not CDsEnabled
    Bastion:Print('Arcane Cooldowns ' .. (CDsEnabled and 'enabled' or 'disabled'))
end)

---@return boolean
local function CombatRotation()
  return false
end


---@return boolean
local function OutOfCombatRotation()
    return false
end


local isRunning = false

ArcaneModule:Sync(function()
  if not isRunning then
      Bastion:Print('Arcane Started')
      isRunning = true
  end

  if not Player:IsAlive() or Player:IsMounted() then
      return false
  end

  if Player:IsAffectingCombat() or IsCurrentSpell(AutoAttack:GetID()) then
      -- Combat Rotation
      return CombatRotation()
  else 
      -- Out Of Combat Rotation
      return OutOfCombatRotation()
  end
end)

Bastion:Register(ArcaneModule)